let tabId;
let btn; // You can define internal variables otside exported file, they will stay private and easier/shorter to use. But sometimes you want to use this.something -- because then you can access it from console
let tokenBar;
let cpyToken;

export default class State {
	constructor(id) {
		tabId = id;
		btn = document.getElementById('activate');
		tokenBar = document.getElementById('token-toolbar');
		cpyToken = document.getElementById('copy-token');
	}

	setActive(token) {
		// const title = `${extName} (Active)`;
		// chrome.pageAction.show(tabId);
		// chrome.pageAction.setTitle({ tabId, title });
		if (tabId) chrome.browserAction.setBadgeText({"text": "Live", tabId });

		// update activation button after little delay for better ux
		setTimeout(
			() => {
				btn.classList.remove('connecting');
				btn.classList.add('active');
				tokenBar.classList.remove('hidden');
				cpyToken.innerText = token;
			},
			300
		);

		// btn.classList.remove('connecting');
		// btn.classList.add('active');
		// $('#activate > span').text("Active");
	}

	setInactive() {
		// const title = `${extName} (Inactive)`;
		// chrome.pageAction.hide(tabId);
		// chrome.pageAction.setTitle({ tabId, title });
		if (tabId) chrome.browserAction.setBadgeText({ tabId });

		tokenBar.classList.add('hidden');
		btn.classList.remove('active', 'connecting');
	}

	setConnecting() {
		btn.classList.remove('active');
		btn.classList.add('connecting');
	}

	static copyToken(el) {
		el.classList.add('focus');
		setTimeout(() => { el.classList.remove('focus') }, 300);
		let tokenSpan = document.getElementById('copy-token');

		if (document.queryCommandSupported('copy') === true) {
			tokenSpan.classList.add('selected');
			setTimeout(() => { tokenSpan.classList.remove('selected') }, 300);

			let textArea = document.createElement("textarea");
			textArea.value = "?zraytok=" + tokenSpan.innerText; //The.token();
			document.body.appendChild(textArea);
			textArea.select();
			try {
				document.execCommand('copy');
			}
			catch (err) {
				console.log('unable to copy');
			}
			document.body.removeChild(textArea);
		}
		else {
			// Fallback if browser doesn't support .execCommand('copy')
			window.prompt("Copy to clipboard: Ctrl+C or Command+C, Enter", tokenSpan.innerText);
		}
	}
}
