/* Immutable values container */
let __inst = false;
let data = {
	tabId: '',
	token: '',
	host: '',
	protocol: '',
	timing: {}
};

export default class The {

	constructor(init) {
		if (__inst !== false) {
			throw Error("double init");
		}
		__inst = true;
		data = init;
	}

	set(str, value) {
		data[str] = value;
	}

	setRequestTiming(str) {
		data.timing[str] = Date.now();
	}

	static getRequestTiming(str) {
		let value = data.timing[str] || 0;
		data.timing[str] = 0;

		return value;
	}

	static get(str) {
		return data[str];
	}

	/**
	 * @returns {number}
	 */
	static tabId() {
		return data.tabId;
	}

	/**
	 * @returns {string}
	 */
	static host() {
		return data.host;
	}

	/**
	 * @returns {string}
	 */
	static protocol() {
		return data.protocol;
	}

	/**
	 * @returns {string}
	 */
	static token() {
		return data.token;
	}
}