import dom from "../elements/Dom.js";
import Sortable from "../elements/Sortable.js";
import Tabable from "../elements/Tabable.js";

export default class ResponsePage {
	constructor(request, prefix) {
		// console.log('ResponsePage::construct', request, prefix);
		// this.request = request;
		this.name = prefix + '-pg-response';
		this.tabs = new Tabable({}, 'Response', prefix + '-pg');
	}

	get() {
		return this.tabs.get();
	}

	headers(data) {
		let table = new Sortable(
			{
				Name: {width: "35%"},
				Value: {width: "65%", code: true}
			},
			this.name + '-headers'
		);

		let rows = [];
		for (let key in data) {
			let head = data[key].split(':');
			rows.push({
				'Name': head[0].trim(),
				'Value': head[1].trim()
			})
		}
		table.addRows(rows);

		this.tabs.append('Headers', table.get());
		this.tabs.enable('Headers');

		this.tabs.initClick('Headers');
	}

	body(data) {
		let body = dom.div({class: "raw-body", text:data});

		this.tabs.append('Raw body', body);
		this.tabs.enable('Raw body');

		this.tabs.initClick('Raw body');
	}
}